# Enum Class KllSketch.SketchStructure

java.lang.Object
java.lang.Enum<KllSketch.SketchStructure>
org.apache.datasketches.kll.KllSketch.SketchStructure

All Implemented Interfaces:
  `Serializable, Comparable<KllSketch.SketchStructure>, Constable`

Enclosing class:
  `KllSketch`

public static enum KllSketch.SketchStructure extends Enum<KllSketch.SketchStructure>
Used primarily to define the structure of the serialized sketch. Also used by the Heap Sketch.

Author:
  Lee Rhodes, Kevin Lang, Alexander Saydakov

## Nested Class Summary

### Nested classes/interfaces inherited from class Enum

`Enum.EnumDesc<E>`

## Enum Constant Summary

Enum Constants
Enum Constant
Description
`COMPACT_EMPTY`
Compact Empty Structure
`COMPACT_FULL`
Compact Full Preamble Structure
`COMPACT_SINGLE`
Compact Single Item Structure
`UPDATABLE`
Updatable Preamble Structure

## Method Summary

Modifier and Type
Method
Description
`int`
`getPreInts()`
gets the Preamble Integers for this Structure.
`int`
`getSerVer()`
gets the Serialization Version for this Structure.
`static KllSketch.SketchStructure`
`getSketchStructure(int preInts, int serVer)`
gets the SketchStructure given preInts and serVer.
`static KllSketch.SketchStructure`
`valueOf(String name)`
Returns the enum constant of this class with the specified name.
`static KllSketch.SketchStructure[]`
`values()`
Returns an array containing the constants of this enum class, in the order they are declared.

### Methods inherited from class Enum

`compareTo, describeConstable, equals, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

### Methods inherited from class Object

`getClass, notify, notifyAll, wait, wait, wait`

## Enum Constant Details

### COMPACT_EMPTY

public static final KllSketch.SketchStructure COMPACT_EMPTY
Compact Empty Structure

### COMPACT_SINGLE

public static final KllSketch.SketchStructure COMPACT_SINGLE
Compact Single Item Structure

### COMPACT_FULL

public static final KllSketch.SketchStructure COMPACT_FULL
Compact Full Preamble Structure

### UPDATABLE

public static final KllSketch.SketchStructure UPDATABLE
Updatable Preamble Structure

## Method Details

### values

public static KllSketch.SketchStructure[] values()
Returns an array containing the constants of this enum class, in the order they are declared.

Returns:
  an array containing the constants of this enum class, in the order they are declared

### valueOf

public static KllSketch.SketchStructure valueOf(String name)
Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)

Parameters:
  `name` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `IllegalArgumentException` - if this enum class has no constant with the specified name
  `NullPointerException` - if the argument is null

### getPreInts

public int getPreInts()
gets the Preamble Integers for this Structure.

Returns:
  the Preamble Integers for this Structure

### getSerVer

public int getSerVer()
gets the Serialization Version for this Structure.

Returns:
  the Serialization Version for this Structure.

### getSketchStructure

public static KllSketch.SketchStructure getSketchStructure(int preInts, int serVer)
gets the SketchStructure given preInts and serVer.

Parameters:
  `preInts` - the given preamble size in integers
  `serVer` - the given Serialization Version
Returns:
  the SketchStructure given preInts and serVer.